#!/usr/bin/perl
use strict;
use CGI;
use SOAP::Lite;
use Time::Local;
use MIME::Base64;

use constant DEFAULT_TIMESPAN => 3600; # 60 min * 60 seconds = 3600 seconds = 1 hour

### START OF WEB SERVCE SETTINGS ###
my $webservice_password = 'test1234';
my $webservice_url = 'http://server/cacti/plugins/nmidWebService/webservice.php?wsdl';
my $tmp_dir = '/tmp/';
my $cacti_userid = 'test';
my $cacti_pwd = 'test123'; # Can also be the MobileToken
### END OF WEB SERVCE SETTINGS ###

my $query = CGI->new();
my $start = $query->param('start') || time - DEFAULT_TIMESPAN;
my $end = $query->param('end') || time;
my $lgid = $query->param('lgid') || 1;
my $height = $query->param('height') || 100;
my $width = $query->param('width') || 800;
my $type = $query->param('type') || 'false';

my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);

if ( $type eq "daily" ) {
        $start = time - 86400; # 1 day = 3600 secs * 24
        $end = time;
}
elsif ( $type eq "weekly" ) {
        $start = time - 604800; # 7 days = 3600 secs * 24 * 7
        $end = time;
}
elsif ( $type eq "monthly" ) {
        $start = time - 2678400; # a month always has 31 days ;-)
        $end = time;
}
elsif ( $type eq "yearly" ) {
        $start = timelocal($sec,$min,$hour,$mday,$mon,$year - 1); # let's assume we won't have a year 0000 ...
        $end = time;
}

# Get secure information directly from the web-service
my $sessionKey = SOAP::Lite->service($webservice_url)->authUser($webservice_password, $cacti_userid,  $cacti_pwd);
# We can now use the session key to validate our requests. Let's get the graph requested.
my $image = SOAP::Lite->service($webservice_url)->getGraph( $sessionKey, $lgid, $start, $end, $height, $width );
$image = decode_base64($image);

print "Content-type: image/png\n\n";
binmode(STDOUT);
print $image;

exit(0);
